package edu.uoc.tfc.sosuna.gestreform.service;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import edu.uoc.tfc.sosuna.gestreform.model.Client;

/**
 * Interficie del API de negoci per a gestionar entitats del tipus Client.
 */
public interface ClientService {

    /**
     * Crear un client.
     * 
     * @param client L'entitat a crear
     * @return L'entitat creada
     */
    ServiceResults<Client> crea(Client client);
	
	/**
     * Desar el client.
     * 
     * @param client L'entitat a modificar
     * @return L'entitat modificada
     */
    ServiceResults<Client> modifica(Client client);

    /**
     *  Obtenir tots els clients.
     *  
     *  @param Dades de paginacio
     *  @return La llista d'entitats trobades
     */
    ServiceResults<Page<Client>> llista(Pageable pageable);

    /**
     *  Cercar per ID un client.
     *  
     *  @param id El ID de l'entitat
     *  @return L'entitat trobada
     */
    ServiceResults<Client> consulta(Long id);

}
