package edu.uoc.tfc.sosuna.gestreform.service;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import edu.uoc.tfc.sosuna.gestreform.model.Manobre;

/**
 * Interficie del API de negoci per a gestionar entitats del tipus Manobre.
 */
public interface ManobreService {

    /**
     * Crear un manobre.
     * 
     * @param manobre L'entitat a crear
     * @return L'entitat creada
     */
    ServiceResults<Manobre> crea(Manobre manobre);

    /**
     * Desar el manobre.
     * 
     * @param manobre L'entitat a modificar
     * @return L'entitat modificada
     */
    ServiceResults<Manobre> modifica(Manobre manobre);

    /**
     *  Obtenir tots els manobres.
     *  
     *  @param Dades de paginacio
     *  @return La llista d'entitats trobades
     */
    ServiceResults<Page<Manobre>> llista(Pageable pageable);

    /**
     *  Cercar per ID un manobre.
     *  
     *  @param id El ID de l'entitat
     *  @return L'entitat trobada
     */
    ServiceResults<Manobre> consulta(Long id);

}
