package edu.uoc.tfc.sosuna.gestreform.service;

import java.util.ArrayList;
import java.util.List;

public class ServiceResults<T> {
	
	public ServiceResults() {
	}
	
	public ServiceResults(T resultData) {
		this.resultData = resultData;
	}
	
	private T resultData;
	private List<ServiceMessage> messages = new ArrayList<>();
	private List<ServiceMessage> warnings = new ArrayList<>();
	private List<ServiceMessage> errors = new ArrayList<>();
	
	public T getResultData() {
		return resultData;
	}
	public void setResultData(T resultData) {
		this.resultData = resultData;
	}
	public List<ServiceMessage> getMessages() {
		return messages;
	}
	public void setMessages(List<ServiceMessage> messages) {
		this.messages = messages;
	}
	public List<ServiceMessage> getWarnings() {
		return warnings;
	}
	public void setWarnings(List<ServiceMessage> warnings) {
		this.warnings = warnings;
	}
	public List<ServiceMessage> getErrors() {
		return errors;
	}
	public void setErrors(List<ServiceMessage> errors) {
		this.errors = errors;
	}
	
	public void addMessage(ServiceMessage msg) {
		this.messages.add(msg);
	}
	public void addWarning(ServiceMessage wrn) {
		this.messages.add(wrn);
	}
	public void addError(ServiceMessage err) {
		this.messages.add(err);
	}

	public void addMessage(String code, String message, Object... args) {
		this.messages.add(new ServiceMessage(code, message, args));
	}
	public void addWarning(String code, String message, Object... args) {
		this.warnings.add(new ServiceMessage(code, message, args));
	}
	public void addError(String code, String message, Object... args) {
		this.errors.add(new ServiceMessage(code, message, args));
	}
	
	public boolean hasMessages() {
		return this.messages!=null && this.messages.size()>0;
	}
	public boolean hasWarnings() {
		return this.warnings!=null && this.warnings.size()>0;
	}
	public boolean hasErrors() {
		return this.errors!=null && this.errors.size()>0;
	}
	
}
