package edu.uoc.tfc.sosuna.gestreform.service;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import edu.uoc.tfc.sosuna.gestreform.model.Usuari;

/**
 * API de negoci per a manipular usuaris.
 */
public interface UsuariService {

	/**
     * Crear un usuari 
     * 
     * @param usuari
     * @return Usuari desat
     */
    ServiceResults<Usuari> crea(Usuari usuari);
	
	/**
     * Desar un usuari 
     * 
     * @param usuari
     * @return Usuari desat
     */
    ServiceResults<Usuari> modifica(Usuari usuari);

    /**
     *  Obtenir tots els usuaris (amb paginacio!).
     */
    ServiceResults<Page<Usuari>> llista(Pageable pageable);

    /**
     *  Obtenir tots els usuaris (amb paginacio!).
     */
    ServiceResults<Page<Usuari>> llistaPerPerfil(String profileId, Pageable pageable);
    
    /**
     *  Obtenir un usuari pel seu ID
     */
    ServiceResults<Usuari> consulta(Long id);

    /**
     *  Obtenir un usuari pel seu login
     */
    ServiceResults<Usuari> consultaPerNomUsuari(String login);
    
}
