package edu.uoc.tfc.sosuna.gestreform.persistence.dao;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import edu.uoc.tfc.sosuna.gestreform.model.Pressupost;

/**
 * JpaRepository ja implementa per defecte les operacions CRUD
 * 
 * @author sosuna
 */
public interface PressupostDao extends JpaRepository<Pressupost,Long> {

    /**
     * Metode especial pel llistat de pressupostos, on surten dades del client.
     * Amb el metode findAll() heredat, obtenir el client del pressupost suposa fer 1 consulta extra per cada 
     * pressupost retornat.
     * Amb aquest metode forcem 1 sola lectura.
     * 
     * @param id
     * @return
     */
	@Query("select pressupost from Pressupost pressupost left join fetch pressupost.manobres where pressupost.id =:id")
    Pressupost findWithClients(@Param("id") Long id);

}
