package edu.uoc.tfc.sosuna.gestreform.persistence.dao;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;

import edu.uoc.tfc.sosuna.gestreform.model.Usuari;
import edu.uoc.tfc.sosuna.gestreform.model.enumeration.PerfilUsuari;

/**
 * JpaRepository ja implementa per defecte les operacions CRUD
 * 
 * @author sosuna
 */
public interface UsuariDao extends JpaRepository<Usuari,Long> {

    Usuari findOneByNomUsuari(String nomUsuari);
    Page<Usuari> findAllByPerfil(PerfilUsuari perfil, Pageable pageable);

}
