(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .controller('UsuariDialogController', UsuariDialogController);

    UsuariDialogController.$inject = ['$scope', '$stateParams', '$uibModalInstance', 'entity', 'UsuariService'];

    function UsuariDialogController ($scope, $stateParams, $uibModalInstance, entity, UsuariService) {
        var vm = this;
        vm.usuari = entity;
        vm.load = function(id) {
            UsuariService.get({id : id}, function(result) {
                vm.usuari = result;
            });
        };

        var onSaveSuccess = function (result) {
            $scope.$emit('gestreformApp:usuariUpdate', result);
            $uibModalInstance.close(result);
            vm.isSaving = false;
        };

        var onSaveError = function () {
            vm.isSaving = false;
        };

        vm.save = function () {
            vm.isSaving = true;
            if (vm.usuari.id !== null) {
                UsuariService.update(vm.usuari, onSaveSuccess, onSaveError);
            } else {
                UsuariService.save(vm.usuari, onSaveSuccess, onSaveError);
            }
        };

        vm.clear = function() {
            $uibModalInstance.dismiss('cancel');
        };
    }
})();
