(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .config(stateConfig);

    stateConfig.$inject = ['$stateProvider', 'ApplicationConstants'];

    function stateConfig($stateProvider, ApplicationConstants) {
        $stateProvider
        .state('usuari', {
            parent: 'forms',
            url: '/usuari',
            data: {
                profiles: ['ADMINISTRADOR'],
                pageTitle: 'Usuaris'
            },
            views: {
                'content@': {
                    templateUrl: ApplicationConstants.adminusuarisWebModuleRoot + '/app/forms/usuari/usuaris.html',
                    controller: 'UsuariController',
                    controllerAs: 'vm'
                }
            },
            resolve: {
            }
        })
        .state('usuari.new', {
            parent: 'usuari',
            url: '/new',
            data: {
                profiles: ['ADMINISTRADOR']
            },
            onEnter: ['$stateParams', '$state', '$uibModal', function($stateParams, $state, $uibModal) {
                $uibModal.open({
                    templateUrl: ApplicationConstants.adminusuarisWebModuleRoot + '/app/forms/usuari/usuari-dialog.html',
                    controller: 'UsuariDialogController',
                    controllerAs: 'vm',
                    backdrop: 'static',
                    size: 'lg',
                    resolve: {
                        entity: function () {
                            return {
                                nif: null,
                                nom: null,
                                cognom1: null,
                                cognom2: null,
                                email: null,
                                telefon: null,
                                nomUsuari: null,
                                contrasenya: null,
                                perfil: null,
                                id: null
                            };
                        }
                    }
                }).result.then(function() {
                    $state.go('usuari', null, { reload: true });
                }, function() {
                    $state.go('usuari');
                });
            }]
        })
        .state('usuari.edit', {
            parent: 'usuari',
            url: '/{id}/edit',
            data: {
                profiles: ['ADMINISTRADOR']
            },
            onEnter: ['$stateParams', '$state', '$uibModal', function($stateParams, $state, $uibModal) {
                $uibModal.open({
                    templateUrl: ApplicationConstants.adminusuarisWebModuleRoot + '/app/forms/usuari/usuari-dialog.html',
                    controller: 'UsuariDialogController',
                    controllerAs: 'vm',
                    backdrop: 'static',
                    size: 'lg',
                    resolve: {
                        entity: ['UsuariService', function(UsuariService) {
                            return UsuariService.get({id : $stateParams.id});
                        }]
                    }
                }).result.then(function() {
                    $state.go('usuari', null, { reload: true });
                }, function() {
                    $state.go('^');
                });
            }]
        });
    }

})();
