/**
 * Aqui configurem generalitats dels accessos al API REST 
 */
(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .config(httpConfig);

    httpConfig.$inject = ['$urlRouterProvider', '$httpProvider', 'httpRequestInterceptorCacheBusterProvider', '$urlMatcherFactoryProvider'];

    function httpConfig($urlRouterProvider, $httpProvider, httpRequestInterceptorCacheBusterProvider, $urlMatcherFactoryProvider) {
        
        // Configurem "angular-cache-buster" per fer no-cachejables totes les peticions al API REST
        httpRequestInterceptorCacheBusterProvider.setMatchlist([/.*api.*/], true);

        // Si es demana una URL desconeguda, per defecte redirigirem a la pantalla inicial.
        $urlRouterProvider.otherwise('/');

        // Automatitzem l'enviament del header d'autenticacio OAUTH a tots els accessos HTTP.
        $httpProvider.interceptors.push('oauthHeaderInterceptor');
        // Convertim els errors del API REST en events per facilitar el tractament.
        $httpProvider.interceptors.push('errorHandlerInterceptor');
        // Convertim els missatges rebuts del servidor (en forma de headers especials) en events per facilitar el tractament.  
        $httpProvider.interceptors.push('notificationInterceptor');

    }
})();
