/**
 * Aquesta directiva s'aplica a un formulari Bootstrap, i fa que els camps amb errors 
 * generats per Angular Forms es ressaltin. 
 */
(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .directive('showValidation', showValidation);

    function showValidation () {
        var directive = {
            restrict: 'A',
            require: 'form',
            link: linkFunc
        };

        return directive;

        function linkFunc (scope, element) {
            element.find('.form-group').each(function() {
                var $formGroup = angular.element(this);
                var $inputs = $formGroup.find('input[ng-model],textarea[ng-model],select[ng-model]');

                if ($inputs.length > 0) {
                    $inputs.each(function() {
                        var $input = angular.element(this);
                        scope.$watch(function() {
                            return $input.hasClass('ng-invalid') && $input.hasClass('ng-dirty');	// Es ressalta l'error si el valor es invalid i s'ha modificat el camp
                        }, function(isInvalid) {
                            $formGroup.toggleClass('has-error', isInvalid);	// CSS class de Bootstrap per indicar error.
                        });
                    });
                }
            });
        }
    }
})();
