/**
 * Amb aquesta directiva podem amagar parts de la pantalla en funcio del perfil de l'usuari
 */
(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .directive('hasAnyProfile', hasAnyProfile);

    hasAnyProfile.$inject = ['AuthorizationService'];
    
    function hasAnyProfile(AuthorizationService) {
        var directive = {
            restrict: 'A',
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, element, attrs) {
            var profiles = attrs.hasAnyProfile.replace(/\s+/g, '').split(',');

            var setVisible = function () {
                    element.removeClass('hidden');
                },
                setHidden = function () {
                    element.addClass('hidden');
                },
                defineVisibility = function (reset) {
                    var result;
                    if (reset) {
                        setVisible();
                    }

                    result = AuthorizationService.hasAnyProfile(profiles);
                    if (result) {
                        setVisible();
                    } else {
                        setHidden();
                    }
                };

            if (profiles.length > 0) {
                defineVisibility(true);

                scope.$watch(function() {
                    return AuthorizationService.isAuthenticated();
                }, function() {
                    defineVisibility(true);
                });
            }
        }
    }
})();
