/**
 * Amb aquest interceptor fem que totes les peticions HTTP enviades amb 
 * el servei $http incorporin el header "Bearer" amb el token d'autenticacion OAUTH necessari.
 * Aquest token es creat al realitzar el login
 * TO-DO: Controlar expiracio del token!
 * 
 *  Simplificacio de:
 *  	https://github.com/cotag/oauth-interceptor/blob/master/intercept/communication.js
 */
(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .factory('oauthHeaderInterceptor', oauthHeaderInterceptor);

    oauthHeaderInterceptor.$inject = ['$localStorage'];

    function oauthHeaderInterceptor ($localStorage) {
        var service = {
            request: request
        };

        return service;

        function request (config) {
            config.headers = config.headers || {};
            if ($localStorage.authenticationToken) {
                config.headers.Authorization = 'Bearer ' + $localStorage.authenticationToken.access_token;
            }
            
            return config;
        }
    }
})();
