/**
 * Amb aquest interceptor convertim els errors del API REST en events d'aplicacio "gestreformApp.httpError".
 * D'aquesta manera a cada pantalla, en lloc d'escoltar a respostes HTTP, escoltem events.
 * Aixo possibilita no haver d'enregistrar listeners a cada peticio que fem.
 * 
 * Inspirat en:
 *  	http://stackoverflow.com/questions/20491182/angularjs-http-interceptor-show-bootstrap-alert
 */
(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .factory('errorHandlerInterceptor', errorHandlerInterceptor);

    errorHandlerInterceptor.$inject = ['$q', '$rootScope'];

    function errorHandlerInterceptor ($q, $rootScope) {
        var service = {
            responseError: responseError
        };

        return service;

        function responseError (response) {
        	sendEvent(response);
            return $q.reject(response);
        }
        
        function sendEvent(response) {
        	// Convertim l'error HTTP a event
            $rootScope.$emit('gestreformApp.httpError', response);
        }
    }
})();
