(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .controller('NavigationBarController', NavigationBarController);

    NavigationBarController.$inject = ['$location', '$state', 'AuthenticationService', 'AuthorizationService', 'LoginService'];

    function NavigationBarController ($location, $state, AuthenticationService, AuthorizationService, LoginService) {
        var vm = this;

        vm.navCollapsed = true;
        vm.isAuthenticated = AuthorizationService.isAuthenticated;
        vm.login = login;
        vm.logout = logout;
        vm.$state = $state;

        function login () {
            LoginService.open();
        }

        function logout () {
            AuthenticationService.logout();
            $state.go('home');
        }
    }
})();
