/**
 * TODO: 
 * 		Implementacio cutre d'autenticacio amb OAUTH
 * 		Provar: https://github.com/oauthjs/angular-oauth2
 */
(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .factory('OAuth2AuthenticationService', OAuth2AuthenticationService);

    OAuth2AuthenticationService.$inject = ['$http', '$localStorage', 'base64', 'ApplicationConstants'];

    function OAuth2AuthenticationService ($http, $localStorage, base64, ApplicationConstants) {
    	
        var service = {
            login: login,
            logout: logout
        };

        return service;

        function login (credentials) {
            var data = 
            	'username=' +  encodeURIComponent(credentials.username) + 
            	'&password=' + encodeURIComponent(credentials.password) + 
            	'&grant_type=' + encodeURIComponent('password') + 
            	'&scope=' + encodeURIComponent('read write') + 
            	'&client_secret=' + encodeURIComponent(ApplicationConstants.authentication.clientSecret) +
            	'&client_id=' + encodeURIComponent(ApplicationConstants.authentication.clientId);

            var authRequestKey = base64.encode(ApplicationConstants.authentication.clientId + ':' + ApplicationConstants.authentication.clientSecret); 
            
            // TODO: Cutre!! Mirar si podem fer servir una llibreria "oficial" per a tractar amb OAUTH!!
            return $http.post(ApplicationConstants.oauthRootEndpoint + '/token', data, {		
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded',
                    'Accept': 'application/json',
                    'Authorization': ('Basic ' + authRequestKey)
                }
            }).success(authSucess);

            function authSucess (response) {
            	// Desem les dades d'autenticacio exitosa al localStorage
                $localStorage.authenticationToken = response;
                return response;
            }
        }

        function logout () {
            $http.post(ApplicationConstants.logoutEndpoint).then(function() {
                delete $localStorage.authenticationToken;
            });
        }
    }
})();
