/**
 * Servei per a realitzar l'autenticacio.
 */
(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .factory('AuthenticationService', AuthenticationService);

    AuthenticationService.$inject = ['$rootScope', '$state', '$q', 'AuthorizationService', 'OAuth2AuthenticationService', 'Account', 'LoginService'];

    function AuthenticationService ($rootScope, $state, $q, AuthorizationService, OAuth2AuthenticationService, Account, LoginService) {
        var service = {
            authorize: authorize,
            login: login,
            logout: logout,
        };

        return service;

        function authorize (force) {
            var authReturn = AuthorizationService.identity(force).then(authThen);

            return authReturn;

            function authThen () {
                var isAuthenticated = AuthorizationService.isAuthenticated();

                if ($rootScope.toState.data.profiles && $rootScope.toState.data.profiles.length > 0 && !AuthorizationService.hasAnyProfile($rootScope.toState.data.profiles)) {
                	// L'usuari no esta autenticat. El fotem fora i que s'en vagi de nou al login
                    $state.go('accessdenied');
                }
            }
        }

        function login (credentials, callback) {
            var cb = callback || angular.noop;
            var deferred = $q.defer();

            OAuth2AuthenticationService.login(credentials)
                .then(loginThen)
                .catch(function (err) {
                    // Error a l'autenticacio.
                	// Actuem com si fos un logout
                	this.logout();
                    deferred.reject(err);
                    return cb(err);
                }.bind(this));	// Pq collons no funciona sense aixo???

            function loginThen (data) {
                AuthorizationService.identity(true).then(function(account) {
                    deferred.resolve(data);
                });
                return cb();
            }

            return deferred.promise;
        }


        function logout () {
        	// Contactem al servidor per eliminar el token de la DB
            OAuth2AuthenticationService.logout();
            // Esborrem les dades locals d'autenticacio
            AuthorizationService.authenticate(null);

            // Esborrem les dades de l'estat actual de l'aplicacio
            $rootScope.previousStateName = undefined;
            $rootScope.previousStateNameParams = undefined;
        }
    }
})();
