(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .controller('ClientDialogController', ClientDialogController);

    ClientDialogController.$inject = ['$scope', '$stateParams', '$uibModalInstance', 'entity', 'ClientService'];

    function ClientDialogController ($scope, $stateParams, $uibModalInstance, entity, ClientService) {
        var vm = this;
        vm.client = entity;
        vm.load = function(id) {
            ClientService.get({id : id}, function(result) {
                vm.client = result;
            });
        };

        var onSaveSuccess = function (result) {
            $uibModalInstance.close(result);
            vm.isSaving = false;
        };

        var onSaveError = function () {
            vm.isSaving = false;
        };

        vm.save = function () {
            vm.isSaving = true;
            if (vm.client.id !== null) {
                ClientService.update(vm.client, onSaveSuccess, onSaveError);
            } else {
                ClientService.save(vm.client, onSaveSuccess, onSaveError);
            }
        };

        vm.clear = function() {
            $uibModalInstance.dismiss('cancel');
        };
    }
})();
