(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .controller('ManobreDialogController', ManobreDialogController);

    ManobreDialogController.$inject = ['$scope', '$stateParams', '$uibModalInstance', 'entity', 'ManobreService', 'PressupostService'];

    function ManobreDialogController ($scope, $stateParams, $uibModalInstance, entity, ManobreService, PressupostService) {
        var vm = this;
        vm.manobre = entity;

        vm.load = function(id) {
            ManobreService.get({id : id}, function(result) {
                vm.manobre = result;
            });
        };

        var onSaveSuccess = function (result) {
            $uibModalInstance.close(result);
            vm.isSaving = false;
        };

        var onSaveError = function () {
            vm.isSaving = false;
        };

        vm.save = function () {
            vm.isSaving = true;
            if (vm.manobre.id !== null) {
                ManobreService.update(vm.manobre, onSaveSuccess, onSaveError);
            } else {
                ManobreService.save(vm.manobre, onSaveSuccess, onSaveError);
            }
        };

        vm.clear = function() {
            $uibModalInstance.dismiss('cancel');
        };
    }
})();
