(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .config(stateConfig);

    stateConfig.$inject = ['$stateProvider', 'ApplicationConstants'];

    function stateConfig($stateProvider, ApplicationConstants) {
        $stateProvider
        .state('manobre', {
            parent: 'forms',
            url: '/manobre',
            data: {
                profiles: ['COMERCIAL', 'GERENT'],
                pageTitle: 'Manobres'
            },
            views: {
                'content@': {
                    templateUrl: ApplicationConstants.gestiotreballWebModuleRoot + '/app/forms/manobre/manobres.html',
                    controller: 'ManobreController',
                    controllerAs: 'vm'
                }
            },
            resolve: {
            }
        })
        .state('manobre.new', {
            parent: 'manobre',
            url: '/new',
            data: {
                profiles: ['COMERCIAL', 'GERENT']
            },
            onEnter: ['$stateParams', '$state', '$uibModal', function($stateParams, $state, $uibModal) {
                $uibModal.open({
                    templateUrl: ApplicationConstants.gestiotreballWebModuleRoot + '/app/forms/manobre/manobre-dialog.html',
                    controller: 'ManobreDialogController',
                    controllerAs: 'vm',
                    backdrop: 'static',
                    size: 'lg',
                    resolve: {
                        entity: function () {
                            return {
                                nif: null,
                                nom: null,
                                cognom1: null,
                                cognom2: null,
                                email: null,
                                telefon: null,
                                adreca: null,
                                id: null
                            };
                        }
                    }
                }).result.then(function() {
                    $state.go('manobre', null, { reload: true });
                }, function() {
                    $state.go('manobre');
                });
            }]
        })
        .state('manobre.edit', {
            parent: 'manobre',
            url: '/{id}/edit',
            data: {
                profiles: ['COMERCIAL', 'GERENT']
            },
            onEnter: ['$stateParams', '$state', '$uibModal', function($stateParams, $state, $uibModal) {
                $uibModal.open({
                    templateUrl: ApplicationConstants.gestiotreballWebModuleRoot + '/app/forms/manobre/manobre-dialog.html',
                    controller: 'ManobreDialogController',
                    controllerAs: 'vm',
                    backdrop: 'static',
                    size: 'lg',
                    resolve: {
                        entity: ['ManobreService', function(ManobreService) {
                            return ManobreService.get({id : $stateParams.id});
                        }]
                    }
                }).result.then(function() {
                    $state.go('manobre', null, { reload: true });
                }, function() {
                    $state.go('^');
                });
            }]
        });
    }

})();
