(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .controller('PressupostSelectManobresDialogController', PressupostSelectManobresDialogController);

    PressupostSelectManobresDialogController.$inject = ['$scope', '$rootScope', '$stateParams', '$uibModalInstance', 'ManobreService'];

    function PressupostSelectManobresDialogController ($scope, $rootScope, $stateParams, $uibModalInstance, ManobreService) {
        var vm = this;
        
        vm.manobres = null;
        vm.manobresMap = null;
        
        ManobreService.query(function(result) {
        	vm.manobres = result;
        	initSelectedManobres();
        });
        
        vm.clear = function() {
            $uibModalInstance.dismiss('cancel');
        };
        
        vm.switchManobre = function($event, id) {
        	var element = $event.target;
        	
        	if (element.checked) {
        		selectManobre(id);
        	}
        	else {
        		unselectManobre(id);
        	}
        }
        
        vm.confirmSelectManobres = function() {
        	$rootScope.currentSelectedManobres = [];
        	
        	var manobre = null;
        	for (var key in vm.manobresMap) {
        		if (vm.manobresMap[key]==true) {
        			manobre = lookupManobres(key);
        			$rootScope.currentSelectedManobres.push(manobre);
        		}
        	}
        	
        	$rootScope.confirmSelectManobres();
            $uibModalInstance.dismiss('cancel');
        }; 
        

        function initSelectedManobres() {
        	vm.manobresMap = {};
        	var key = null;
        	for (var i=0; i<vm.manobres.length; i++) {
        		key = ""+vm.manobres[i].id;
        		vm.manobresMap[key] = isSelectedManobre(vm.manobres[i].id);
        	}
        }
        
        function isSelectedManobre(id) {
        	var index = lookupSelectedManobres(id);
        	return (index!=null);
        };
        
        function lookupManobres(id) {
        	for (var i=0; i<vm.manobres.length; i++) {
        		if (vm.manobres[i].id==id) {
        			return vm.manobres[i];
        		}
        	}
        	
        	return null;
        }

        function lookupSelectedManobres(id) {
        	for (var i=0; i<$rootScope.currentSelectedManobres.length; i++) {
        		if ($rootScope.currentSelectedManobres[i].id==id) {
        			return $rootScope.currentSelectedManobres[i];
        		}
        	}
        	
        	return null;
        }
        
    }
})();
