(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .controller('PressupostController', PressupostController);

    PressupostController.$inject = ['$scope', '$state', 'PressupostService'];

    function PressupostController ($scope, $state, PressupostService) {
        var vm = this;
        vm.pressuposts = [];
        
        vm.loadAll = function() {
            PressupostService.query(
            		{
            			flavour: "1"	// Llistat amb format especial per a contenir tambe les dades del client associat al pressuposts
        			}, 
            		function(result) {
            			vm.pressuposts = result;
        			}
    		);
        };

        vm.estatValueLabelMapping = {
			"PENDENT" : "Pendent",
			"CANCELLAT" : "Cancel·lat",
			"DENEGAT" : "Denegat",
			"EN_PROCES" : "En Procés",
			"FINALITZAT": "Finalitzat"
        };        
        
        // Recarreguem la llista de pressupostos quan un pressupost es modifiqui, per a que les dades presentades segueixin consistents.
        $scope.$on("gestreformApp:pressupostUpdate", function() {
        	vm.loadAll();
        });

        vm.loadAll();
    }
})();
