(function() {
    'use strict';
    angular
        .module('gestreformApp')
        .factory('PressupostService', PressupostService);

    PressupostService.$inject = ['$resource', 'moment', 'ApplicationConstants'];

    function PressupostService ($resource, moment, ApplicationConstants) {
        var resourceUrl =  ApplicationConstants.apiRootEndpoint + '/pressuposts/:id';

        return $resource(resourceUrl, {}, {
            'query': { method: 'GET', isArray: true},
            'get': {
                method: 'GET',
                transformResponse: function (data) {
                    data = angular.fromJson(data);
                    data.dataInici = moment(data.dataInici, 'YYYY-MM-DD').toDate();
                    data.dataFi = moment(data.dataFi, 'YYYY-MM-DD').toDate();
                    return data;
                }
            },
            'update': {
                method: 'PUT',
                transformRequest: function (data) {
                	data.dataInici = moment(data.dataInici).format('YYYY-MM-DD');
                    data.dataFi = moment(data.dataFi).format('YYYY-MM-DD');
                    return angular.toJson(data);
                }
            },
            'save': {
                method: 'POST',
                transformRequest: function (data) {
                	data.dataInici = moment(data.dataInici).format('YYYY-MM-DD');
                    data.dataFi = moment(data.dataFi).format('YYYY-MM-DD');
                    return angular.toJson(data);
                }
            }
        });
    }
})();
