(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .controller('HomeController', HomeController);

    HomeController.$inject = ['$rootScope', '$scope', 'AuthorizationService', 'LoginService'];

    function HomeController ($rootScope, $scope, AuthorizationService, LoginService) {
        var vm = this;

        $rootScope.account = null;
        vm.account = null;
        vm.isAuthenticated = null;
        vm.login = LoginService.open;
        $scope.$on('authenticationSuccess', function() {
            getAccount();
        });

        getAccount();

        function getAccount() {
            AuthorizationService.identity().then(function(account) {
            	$rootScope.account = account;
            	vm.account = account;
                vm.isAuthenticated = AuthorizationService.isAuthenticated;
            });
        }
    }
})();
