/**
 * Controlador del modal de login
 */
(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .controller('LoginController', LoginController);

    LoginController.$inject = ['$rootScope', '$state', 'AuthenticationService', '$uibModalInstance'];

    function LoginController ($rootScope,$state, AuthenticationService, $uibModalInstance) {
        var vm = this;

        vm.authenticationError = false;
        vm.cancel = cancel;
        vm.credentials = {};
        vm.login = login;
        vm.password = null;
        vm.username = null;

        function cancel () {
            vm.credentials = {
                username: null,
                password: null
            };
            vm.authenticationError = false;
            $uibModalInstance.dismiss('cancel');
        }

        function login (event) {
            AuthenticationService.login({
                username: vm.username,
                password: vm.password
            }).then(function () {
                // Autenticacio exitosa.
                vm.authenticationError = false;
                $uibModalInstance.close();
                $rootScope.$broadcast('authenticationSuccess');
            }).catch(function () {
                // Autenticacio erronea
            	vm.authenticationError = true;
            });
        }
    }
})();
