/**
 * Serveis emprats pel modal de login
 */
(function() {
    'use strict';

    angular
        .module('gestreformApp')
        .factory('LoginService', LoginService);

    LoginService.$inject = ['$uibModal', 'ApplicationConstants'];

    function LoginService ($uibModal, ApplicationConstants) {
        var service = {
            open: open
        };

        var modalInstance = null;
        
        /**
         * Tancament modal
         */
        var resetModal = function () {
            modalInstance = null;
        };

        return service;

        /**
         * Apertura modal de login
         */
        function open () {
            if (modalInstance !== null) return;
            modalInstance = $uibModal.open({
                templateUrl: ApplicationConstants.mainWebModuleRoot + '/app/home/login.html',
                controller: 'LoginController',
                controllerAs: 'vm'
            });
            modalInstance.result.then(
                resetModal,		// Tancar modal
                resetModal
            );
        }
    }
})();
