package edu.uoc.tfc.sosuna.gestreform.integration;

import org.springframework.boot.orm.jpa.EntityScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.convert.threeten.Jsr310JpaConverters;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import edu.uoc.tfc.sosuna.gestreform.model.Usuari;
import edu.uoc.tfc.sosuna.gestreform.persistence.dao.UsuariDao;

@Configuration
//Configurem SpringData per que generi la implementacio dels repositoris definits per les interficies d'aquest paquet.
@EnableJpaRepositories(basePackageClasses={UsuariDao.class})		
//Configurem Spring per que es faci carrec de la delimitacio de transaccions amb annotations @Transactional
@EnableTransactionManagement											
// Jsr310JpaConverters: Per poder utilitzar els nous tipus temporals de Java8 (JSR-310) com a atributs d'entitats JPA.
// Usuari: Per habilitar el scan d'entitats al paquet on es troba la classe Usuari
@EntityScan(basePackageClasses={Jsr310JpaConverters.class, Usuari.class})	 
/**
 * Confiugracio de la capa de persistencia
 */
public class DatabaseConfiguration {
}
