package edu.uoc.tfc.sosuna.gestreform.rest.dto;

import edu.uoc.tfc.sosuna.gestreform.model.Usuari;

/**
 * Aquest DTO representa el compte del usuari.
 */
public class AccountDTO {

    private Long id;
	private String nomUsuari;
    private String nom;
    private String cognom1;
    private String cognom2;
    private String email;
    private String perfil;
	
    public AccountDTO() {
    }

    public AccountDTO(Usuari user) {
    	this.id = user.getId();
        this.nomUsuari = user.getNomUsuari();
        this.nom = user.getNom();
        this.cognom1 = user.getCognom1();
        this.cognom2 = user.getCognom2();
        this.email = user.getEmail();
        this.perfil = user.getPerfil().name();
    }
    
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNomUsuari() {
		return nomUsuari;
	}

	public void setNomUsuari(String nomUsuari) {
		this.nomUsuari = nomUsuari;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getCognom1() {
		return cognom1;
	}

	public void setCognom1(String cognom1) {
		this.cognom1 = cognom1;
	}

	public String getCognom2() {
		return cognom2;
	}

	public void setCognom2(String cognom2) {
		this.cognom2 = cognom2;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getPerfil() {
		return perfil;
	}

	public void setPerfil(String perfil) {
		this.perfil = perfil;
	}
	
	@Override
    public String toString() {
        return "AccountDTO{" +
            "id = '" + id + "'" +
    		", nomUsuari ='" + nomUsuari + '\'' +
            ", nom ='" + nom + '\'' +
            ", cognom1 ='" + cognom1 + '\'' +
            ", cognom2 ='" + cognom2 + '\'' +
            ", email ='" + email + '\'' +
            ", perfil = '" + perfil + "'" +
            "}";
    }
}
