package edu.uoc.tfc.sosuna.gestreform.rest.dto;

import java.time.LocalDate;
import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import edu.uoc.tfc.sosuna.gestreform.model.enumeration.EstatPressupost;

public class PressupostDTO {

	private Long id;

    @NotNull
    private Float imprt;


    @NotNull
    private EstatPressupost estat;


    @NotNull
    private LocalDate dataInici;


    private LocalDate dataFi;


    @NotNull
    @Size(min = 1, max = 1000)
    private String descripcio;


    private Long clientId;
    private Long comercialId;
    private Set<ManobreDTO> manobres = new HashSet<>();

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    public Float getImprt() {
        return imprt;
    }

    public void setImprt(Float imprt) {
        this.imprt = imprt;
    }
    public EstatPressupost getEstat() {
        return estat;
    }

    public void setEstat(EstatPressupost estat) {
        this.estat = estat;
    }
    public LocalDate getDataInici() {
        return dataInici;
    }

    public void setDataInici(LocalDate dataInici) {
        this.dataInici = dataInici;
    }
    public LocalDate getDataFi() {
        return dataFi;
    }

    public void setDataFi(LocalDate dataFi) {
        this.dataFi = dataFi;
    }
    public String getDescripcio() {
        return descripcio;
    }

    public void setDescripcio(String descripcio) {
        this.descripcio = descripcio;
    }

    public Long getClientId() {
        return clientId;
    }

    public void setClientId(Long clientId) {
        this.clientId = clientId;
    }
    public Long getComercialId() {
        return comercialId;
    }

    public void setComercialId(Long usuariId) {
        this.comercialId = usuariId;
    }
    public Set<ManobreDTO> getManobres() {
        return manobres;
    }

    public void setManobres(Set<ManobreDTO> manobres) {
        this.manobres = manobres;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }

        PressupostDTO pressupostDTO = (PressupostDTO) o;

        if ( ! Objects.equals(id, pressupostDTO.id)) {
			return false;
		}

        return true;
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(id);
    }

    @Override
    public String toString() {
        return "PressupostDTO{" +
            "id=" + id +
            ", imprt='" + imprt + "'" +
            ", estat='" + estat + "'" +
            ", dataInici='" + dataInici + "'" +
            ", dataFi='" + dataFi + "'" +
            ", descripcio='" + descripcio + "'" +
            '}';
    }
}
