package edu.uoc.tfc.sosuna.gestreform.rest.mapper;

import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Component;

import edu.uoc.tfc.sosuna.gestreform.model.Client;
import edu.uoc.tfc.sosuna.gestreform.rest.dto.ClientDTO;

@Component
public class ClientMapperImpl implements ClientMapper {

    @Override
    public ClientDTO clientToClientDTO(Client client) {
        if ( client == null ) {
            return null;
        }

        ClientDTO clientDTO = new ClientDTO();

        clientDTO.setId( client.getId() );
        clientDTO.setNif( client.getNif() );
        clientDTO.setNom( client.getNom() );
        clientDTO.setCognom1( client.getCognom1() );
        clientDTO.setCognom2( client.getCognom2() );
        clientDTO.setEmail( client.getEmail() );
        clientDTO.setTelefon( client.getTelefon() );
        clientDTO.setAdreca( client.getAdreca() );

        return clientDTO;
    }

    @Override
    public List<ClientDTO> clientsToClientDTOs(List<Client> clients) {
        if ( clients == null ) {
            return null;
        }

        List<ClientDTO> list = new ArrayList<ClientDTO>();
        for ( Client client : clients ) {
            list.add( clientToClientDTO( client ) );
        }

        return list;
    }

    @Override
    public Client clientDTOToClient(ClientDTO clientDTO) {
        if ( clientDTO == null ) {
            return null;
        }

        Client client = new Client();

        client.setId( clientDTO.getId() );
        client.setNif( clientDTO.getNif() );
        client.setNom( clientDTO.getNom() );
        client.setCognom1( clientDTO.getCognom1() );
        client.setCognom2( clientDTO.getCognom2() );
        client.setEmail( clientDTO.getEmail() );
        client.setTelefon( clientDTO.getTelefon() );
        client.setAdreca( clientDTO.getAdreca() );

        return client;
    }

    @Override
    public List<Client> clientDTOsToClients(List<ClientDTO> clientDTOs) {
        if ( clientDTOs == null ) {
            return null;
        }

        List<Client> list = new ArrayList<Client>();
        for ( ClientDTO clientDTO : clientDTOs ) {
            list.add( clientDTOToClient( clientDTO ) );
        }

        return list;
    }
}
