package edu.uoc.tfc.sosuna.gestreform.rest.mapper;

import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Component;

import edu.uoc.tfc.sosuna.gestreform.model.Manobre;
import edu.uoc.tfc.sosuna.gestreform.rest.dto.ManobreDTO;

@Component
public class ManobreMapperImpl implements ManobreMapper {

    @Override
    public ManobreDTO manobreToManobreDTO(Manobre manobre) {
        if ( manobre == null ) {
            return null;
        }

        ManobreDTO manobreDTO = new ManobreDTO();

        manobreDTO.setId( manobre.getId() );
        manobreDTO.setNif( manobre.getNif() );
        manobreDTO.setNom( manobre.getNom() );
        manobreDTO.setCognom1( manobre.getCognom1() );
        manobreDTO.setCognom2( manobre.getCognom2() );
        manobreDTO.setEmail( manobre.getEmail() );
        manobreDTO.setTelefon( manobre.getTelefon() );
        manobreDTO.setAdreca( manobre.getAdreca() );

        return manobreDTO;
    }

    @Override
    public List<ManobreDTO> manobresToManobreDTOs(List<Manobre> manobres) {
        if ( manobres == null ) {
            return null;
        }

        List<ManobreDTO> list = new ArrayList<ManobreDTO>();
        for ( Manobre manobre : manobres ) {
            list.add( manobreToManobreDTO( manobre ) );
        }

        return list;
    }

    @Override
    public Manobre manobreDTOToManobre(ManobreDTO manobreDTO) {
        if ( manobreDTO == null ) {
            return null;
        }

        Manobre manobre = new Manobre();

        manobre.setId( manobreDTO.getId() );
        manobre.setNif( manobreDTO.getNif() );
        manobre.setNom( manobreDTO.getNom() );
        manobre.setCognom1( manobreDTO.getCognom1() );
        manobre.setCognom2( manobreDTO.getCognom2() );
        manobre.setEmail( manobreDTO.getEmail() );
        manobre.setTelefon( manobreDTO.getTelefon() );
        manobre.setAdreca( manobreDTO.getAdreca() );

        return manobre;
    }

    @Override
    public List<Manobre> manobreDTOsToManobres(List<ManobreDTO> manobreDTOs) {
        if ( manobreDTOs == null ) {
            return null;
        }

        List<Manobre> list = new ArrayList<Manobre>();
        for ( ManobreDTO manobreDTO : manobreDTOs ) {
            list.add( manobreDTOToManobre( manobreDTO ) );
        }

        return list;
    }
}
