package edu.uoc.tfc.sosuna.gestreform.rest.mapper;

import java.util.List;

import edu.uoc.tfc.sosuna.gestreform.model.Client;
import edu.uoc.tfc.sosuna.gestreform.model.Manobre;
import edu.uoc.tfc.sosuna.gestreform.model.Pressupost;
import edu.uoc.tfc.sosuna.gestreform.model.Usuari;
import edu.uoc.tfc.sosuna.gestreform.rest.dto.PressupostDTO;

/**
 * Mapeig DTO <==> domain object per l'entitat "Pressupost".
 */
public interface PressupostMapper {

    PressupostDTO pressupostToPressupostDTO(Pressupost pressupost);

    List<PressupostDTO> pressupostsToPressupostDTOs(List<Pressupost> pressuposts);

    Pressupost pressupostDTOToPressupost(PressupostDTO pressupostDTO);

    List<Pressupost> pressupostDTOsToPressuposts(List<PressupostDTO> pressupostDTOs);

    default Client clientFromId(Long id) {
        if (id == null) {
            return null;
        }
        Client client = new Client();
        client.setId(id);
        return client;
    }

    default Usuari usuariFromId(Long id) {
        if (id == null) {
            return null;
        }
        Usuari usuari = new Usuari();
        usuari.setId(id);
        return usuari;
    }

    default Manobre manobreFromId(Long id) {
        if (id == null) {
            return null;
        }
        Manobre manobre = new Manobre();
        manobre.setId(id);
        return manobre;
    }
}
