package edu.uoc.tfc.sosuna.gestreform.rest.mapper;

import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Component;

import edu.uoc.tfc.sosuna.gestreform.model.Usuari;
import edu.uoc.tfc.sosuna.gestreform.rest.dto.UsuariDTO;

@Component
public class UsuariMapperImpl implements UsuariMapper {

    @Override
    public UsuariDTO usuariToUsuariDTO(Usuari usuari) {
        if ( usuari == null ) {
            return null;
        }

        UsuariDTO usuariDTO = new UsuariDTO();

        usuariDTO.setId( usuari.getId() );
        usuariDTO.setNif( usuari.getNif() );
        usuariDTO.setNom( usuari.getNom() );
        usuariDTO.setCognom1( usuari.getCognom1() );
        usuariDTO.setCognom2( usuari.getCognom2() );
        usuariDTO.setEmail( usuari.getEmail() );
        usuariDTO.setTelefon( usuari.getTelefon() );
        usuariDTO.setNomUsuari( usuari.getNomUsuari() );
        usuariDTO.setContrasenya( usuari.getContrasenya() );
        usuariDTO.setPerfil( usuari.getPerfil() );

        return usuariDTO;
    }

    @Override
    public List<UsuariDTO> usuarisToUsuariDTOs(List<Usuari> usuaris) {
        if ( usuaris == null ) {
            return null;
        }

        List<UsuariDTO> list = new ArrayList<UsuariDTO>();
        for ( Usuari usuari : usuaris ) {
            list.add( usuariToUsuariDTO( usuari ) );
        }

        return list;
    }

    @Override
    public Usuari usuariDTOToUsuari(UsuariDTO usuariDTO) {
        if ( usuariDTO == null ) {
            return null;
        }

        Usuari usuari = new Usuari();

        usuari.setId( usuariDTO.getId() );
        usuari.setNif( usuariDTO.getNif() );
        usuari.setNom( usuariDTO.getNom() );
        usuari.setCognom1( usuariDTO.getCognom1() );
        usuari.setCognom2( usuariDTO.getCognom2() );
        usuari.setEmail( usuariDTO.getEmail() );
        usuari.setTelefon( usuariDTO.getTelefon() );
        usuari.setNomUsuari( usuariDTO.getNomUsuari() );
        usuari.setContrasenya( usuariDTO.getContrasenya() );
        usuari.setPerfil( usuariDTO.getPerfil() );

        return usuari;
    }

    @Override
    public List<Usuari> usuariDTOsToUsuaris(List<UsuariDTO> usuariDTOs) {
        if ( usuariDTOs == null ) {
            return null;
        }

        List<Usuari> list = new ArrayList<Usuari>();
        for ( UsuariDTO usuariDTO : usuariDTOs ) {
            list.add( usuariDTOToUsuari( usuariDTO ) );
        }

        return list;
    }
}
